﻿Type=Class
Version=3.49
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	Private fx As JFX
	Private Mask() As Char 					'Mask Array
	Private txMask() As Char 				'Text Array
	Private mPane As AnchorPane				
	Private btFocus As Button				'button used to request focus
	Private lbText As Label					'Label used as textfield
	Private pnCaret As Pane					'Caret cursor
	Private CaretTm As Timer				'Caret Cursor Timer
	Private Caret_Pos As Short				'The cursor position in the text
	Private Shdw As String					'Shadow when selected; use if you want.
	Private bColor, tmpColor As Paint		'Background color, temporary color to work
	Private flgIns As Boolean				'Insert on or off
	Private numString As String				'Valid characters for numeric fields
	Private Rflt As Reflector
	Private iniC As Short
	Private endC As Short
	Private Edtbl, Enbld As Boolean	
	Private fr_Owner As Object
	Private	lft, tp,  wdt, hgt As Short
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(frm As Object, f_Cnt As Object,  objId As String, Msk As String, l As Double, t As Double, w As Double, h As Double)
					  'Form Object	 Container		   Object Id   	    Mask		   Left		    Top			 Whidth		  Height	
	fr_Owner = frm
	mPane.Initialize("")
	mPane.Id = objId
	btFocus.Initialize("btFocus")
	bColor = fx.Colors.RGB(171, 171, 171)
	numString = "0123456789"	
	mPane.Style = "-fx-background-color: white; -fx-background-radius: 3;-fx-border-color: #ababab; -fx-border-radius:3;"
	btFocus.Style = "-fx-background-color: transparent;"
	lbText.Initialize("lbText")
	lbText.Style = "-fx-padding: 0 10 0 10; -fx-background-radius: 3"
	lbText.Font = fx.DefaultFont(12)
	lbText.TextColor = fx.Colors.RGB(50,50,50)
	lbText.Alignment = "CENTER_LEFT"
	lbText.MouseCursor = fx.Cursors.TEXT
	pnCaret.Initialize("")
	pnCaret.Style = "-fx-background-color:  rgba(50,50,50,0.4)"
	pnCaret.Visible = False
	CaretTm.Initialize("tm", 500)
	CaretTm.enabled = False
	Edtbl  = True
	Enbld = True
	Shdw = "-fx-effect: dropshadow( three-pass-box , rgba(0,0,0,0.6) , 5, 0.0 , 5 , 5 );"
	Rflt.Target = btFocus
	Rflt.AddEventHandler2("KeyPressed", "onKeyPressedProperty") 	
	sMask(Msk)
	lft = l: tp = t
	Dim inf() As Int = MeasureText("W", lbText.Font)	'determines width and height
	If w = -1 Then
		wdt = 150
	Else
		wdt = w
	End If
	If h = -1 Then h = 25
	hgt = h
	mPane.AddNode(btFocus, 0, 0, wdt, hgt)
	mPane.SetAnchors(btFocus,0,0,0,-1)
	mPane.AddNode(lbText, 0, 0, -1, -1)
	mPane.SetAnchors(lbText,0,0,0,0)
	mPane.AddNode(pnCaret, 4, (h - inf(1)) / 2, 2, inf(1))
	flgIns = True			'Onsert is on
	If f_Cnt Is Pane Then
		Dim pPane As Pane = f_Cnt
		pPane.AddNode(mPane,lft,tp, wdt, hgt)
	else if f_Cnt Is AnchorPane 	Then
		Dim aPane As AnchorPane = f_Cnt
		aPane.AddNode(mPane,lft,tp, wdt, hgt)
	End If
	btFocus.StyleClasses.Clear
	mPane.StyleClasses.Clear
	lbText.StyleClasses.Clear
End Sub

Private Sub sMask(msk As String)
	If msk.Length = 0 Then 
		msk = "??????????????????????????????" 'if mask equal to nothing, mask equal to 30 characters any
	End If
	wdt = msk.Length
	Dim Mask(wdt) As Char
	Dim txMask(wdt) As Char
	For i = 0 To Mask.Length-1				'builds arrays, masks and empty text
		Mask(i) = msk.SubString2(i, i+1)
		If "UL?#".Contains(Mask(i)) Then
			txMask(i) = Chr(32)
		Else
			txMask(i) = Mask(i)
		End If 
	Next
	iniC = 0	
	Do Until "UL?#".Contains(Mask(iniC)) Or iniC=Mask.Length-1
		iniC = iniC + 1
	Loop
	endC = Mask.Length
	Do Until "UL?#".Contains(Mask(endC-1)) Or endC = 0
		endC = endC - 1
	Loop
	Caret_Pos = iniC
	setCaret_Pos	
	putText
End Sub

Private Sub KeyPressed_Event(e As Event)
	Dim KE As Reflector
	KE.Target = e	 ' e is a KeyEvent instance
	Private KeyCode, KeyText As String
'	Private KeyChar, EventType As String
	KeyCode = KE.RunMethod("getCode")
	KeyText = KE.RunMethod("getText")
	kPressed(KeyCode,KeyText)
'	Log("Root Filter : Key " & KeyChar & " " & EventType & " : Code : " & KeyCode & " : Text " & KeyText)
	e.Consume ' Consume the event to stop it bubbling up the scene graph 	
End Sub

Private Sub kPressed(KC As String, KT As String) 
	Dim Flag As Boolean
	Flag=False
	If KC = "TAB" Then 
		btFocus.Enabled = False
		Return
	End If
	If Not (Edtbl) Then Return
	Select Case KC
		Case "HOME" 
			Caret_Pos = iniC
			setCaret_Pos
			Return
		Case "END" 
			Caret_Pos = endC
			setCaret_Pos
			Return
		Case "LEFT"
			If Caret_Pos = iniC  Then Return
			Caret_Pos = Caret_Pos - 1
			Do Until "UL?#".Contains(Mask(Caret_Pos)) Or Caret_Pos = iniC
				Caret_Pos = Caret_Pos - 1
			Loop
			setCaret_Pos
			Return		
		Case "RIGHT"
			If Caret_Pos = endC Then Return
			Caret_Pos = Caret_Pos + 1
			Do Until Caret_Pos = endC Or "UL?#".Contains(Mask(Caret_Pos))   
				Caret_Pos = Caret_Pos + 1
			Loop					
			setCaret_Pos
			Return
		Case "BACK_SPACE"
			If Caret_Pos = iniC Then Return
			Caret_Pos = Caret_Pos - 1
			Do Until "UL?#".Contains(Mask(Caret_Pos)) Or Caret_Pos=iniC
				Caret_Pos = Caret_Pos - 1
			Loop
			MoveText(Caret_Pos, endC - 1, 1)
			txMask(endC-1) = Chr(32)
			putText
			setCaret_Pos
			Return		
		Case "DELETE"
			If Caret_Pos = endC Then Return
			MoveText(Caret_Pos, endC-1, 1)
			txMask(endC-1) = Chr(32)
			putText
			setCaret_Pos
			Return
		Case "INSERT"
			If flgIns Then 
				pnCaret.PrefWidth = 6
			Else
				pnCaret.PrefWidth = 2
			End If
			flgIns = Not(flgIns)
			Return
		Case "ENTER", "DOWN", "TAB"	
			btFocus.Enabled = False
			Return
		Case "UP", "SHIFT", "PAGE_DOWN", "PAGE_UP", "CAPS"
			Return
		Case "F1", "F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12"
			Return
	End Select
	Dim tM As Char
	If Caret_Pos = endC Then Return
	If Mask(Caret_Pos) = "#" Then
		If numString.Contains(KT) Then 
			tM = KT
			Flag = True
		End If
	Else If Mask(Caret_Pos) = "?" Then
		tM = KT
		Flag = True
	Else If Mask(Caret_Pos)="U" Then
		tM = KT.ToUpperCase 
		Flag=True
	Else If Mask(Caret_Pos)="L" Then
		tM = KT.ToLowerCase 
		Flag = True
	Else 
		Flag = False
	End If	
	If Flag Then
		If flgIns Then
			MoveText(endC - 2, Caret_Pos, -1)
		End If
		txMask(Caret_Pos) = tM
		putText
		Caret_Pos = Caret_Pos + 1
		Do Until Caret_Pos = endC Or "UL?#".Contains(Mask(Caret_Pos))   
			Caret_Pos = Caret_Pos + 1
		Loop							
		setCaret_Pos
	End If
End Sub


Private Sub MoveText(fIni As Short, fEnd As Short, fStp As Short)
	Dim Prv As Short = fIni 
	If fStp = -1 Then Prv = Prv + 1
	For i= fIni To fEnd Step fStp
		If "UL?#".Contains(Mask(i)) Then
			If Mask(Prv) = "#" And numString.Contains(txMask(i)) Then
				txMask(Prv)	 = txMask(i)
			Else If Mask(Prv) = "?" Then
				txMask(Prv)	 = txMask(i)
			Else If Mask(Prv) = "U" Then
				Dim t As String = txMask(i)
				txMask(Prv)	 = t.ToUpperCase 
			Else If Mask(Prv) = "L" Then
				Dim t As String = txMask(i)
				txMask(Prv) = t.ToLowerCase
			Else 
				txMask(Prv) = " "
				'Log("Error: Invalid character")
			End If			
			Prv = i
		End If				
	Next		
		
End Sub

Private Sub lbText_MouseClicked (EventData As MouseEvent)
	If SubExists(fr_Owner, mPane.Id & "_MouseClicked") Then 
		CallSubDelayed2(fr_Owner,  mPane.Id & "_MouseClicked", EventData)
	End If
	btFocus.RequestFocus
End Sub

Private Sub lbText_TextChanged (Old As String, New As String)
	If SubExists(fr_Owner, mPane.Id & "_TextChanged") Then
		CallSubDelayed3(fr_Owner,  mPane.Id & "_TextChanged", Old, New)
	End If
End Sub

Private Sub btFocus_FocusChanged (HasFocus As Boolean)
	If SubExists(fr_Owner, mPane.Id & "_FocusChanged") Then
		CallSubDelayed2(fr_Owner,  mPane.Id & "_FocusChanged", HasFocus)
	End If
	If HasFocus Then
		If Caret_Pos < iniC Then Caret_Pos = iniC
		setCaret_Pos
		CaretTm.Enabled = True
		mPane.Style = mPane.Style & Shdw
		tmpColor = bColor
		BorderColor(fx.Colors.Black)
	Else
		CaretTm.Enabled = False
		pnCaret.Visible = False
		btFocus.Enabled = Enbld
		BorderColor(tmpColor)
		mPane.Style = mPane.Style.Replace(Shdw,"")
	End If
End Sub

Private Sub setCaret_Pos
	Dim tx As String
	For i = 0 To Caret_Pos - 1
		tx = tx & txMask(i)
	Next
	Dim inf() As Int = MeasureText(tx, lbText.Font) 
	If lbText.Alignment = "CENTER" Then
		Dim inf1() As Int = MeasureText(lbText.Text, lbText.Font)
		pnCaret.Left = ((lbText.Width-7) -inf1(0))/2 + inf(0) + 5
	Else If lbText.Alignment = "CENTER_RIGHT" Then
		Dim inf1() As Int = MeasureText(lbText.Text, lbText.Font)
		pnCaret.Left = (lbText.Width-14) -inf1(0) + inf(0) + 5 
	Else		'CENTER_LEFT
		pnCaret.Left = inf(0) + 12
	End If
End Sub

Private Sub putText
	Dim tx As String
	For i = 0 To txMask.Length-1
		tx = tx & txMask(i)
	Next
	Dim old As String = lbText.Text
	lbText.Text = tx
	lbText_TextChanged(old, tx)
End Sub	

Private Sub tm_tick
	pnCaret.Visible = Not(pnCaret.Visible)
End Sub

Public Sub Alignment(al As String)
	lbText.Alignment = al
	setCaret_Pos
End Sub

Public Sub BackColor(txC As Paint)
	changeStyle(txC, "-fx-background-color:")
End Sub

Public Sub BorderColor(txC As Paint)
	bColor = txC
	changeStyle(txC, "-fx-border-color:")
End Sub

Private Sub changeStyle(txC As Paint, itStr As String)
	Private rgb() As Short = getRGB(fx.Colors.To32Bit(txC))
	Private tmpStyle As String =itStr & " rgba(" & rgb(1) & ", " & rgb(2) & ", " & rgb(3) & ", " & NumberFormat2(rgb(0)/255,1,2,1,False) & ");"
	Private oldStyle As String = mPane.Style
	If oldStyle.Trim = "" Then
		oldStyle = tmpStyle
	Else
		Private strTmp As String
		Private Pos, Pos1 As Short
		Pos = oldStyle.IndexOf(itStr)
		If Pos = -1 Then
			oldStyle = oldStyle & tmpStyle
		Else
			Pos1 = oldStyle.IndexOf2(";", Pos)
			strTmp = oldStyle.SubString2(Pos,Pos1 + 1)
			oldStyle = oldStyle.Replace(strTmp, tmpStyle)
		End If
	End If	 
	mPane.Style = oldStyle
End Sub

Public Sub TextColor(txC As Paint)
	lbText.TextColor = txC
	Private rgb() As Short = getRGB(fx.Colors.To32Bit(txC))
	pnCaret.Style ="-fx-background-color: rgba(" & rgb(1) & ", " & rgb(2) & ", " & rgb(3) & ", " & NumberFormat2(rgb(0)/255,1,2,1,False) & ");"
End Sub	

Public Sub isEnabled As Boolean
	Return Enbld
End Sub

Public Sub isEditable As Boolean
	Return Edtbl
End Sub	

Public Sub Node As Node
	Return lbText
End Sub

Public Sub Editable(Ed As Boolean)
	Edtbl = Ed
End Sub

Public Sub Enabled(En As Boolean)
	btFocus.Enabled = En
	lbText.Enabled = En
	Enbld = En
	setAlpha
End Sub

private Sub setAlpha
	If Enbld Then
		mPane.Alpha = 1
		lbText.Alpha  = 1
	Else
		mPane.Alpha = 0.6
		lbText.Alpha  = 0.6
	End If
End Sub

public Sub SetTag(tg As Object)
	mPane.Tag = tg
End Sub

Public Sub GetTag() As Object
	Return mPane.Tag
End Sub

Public Sub FormattedText() As String
	Return lbText.Text
End Sub

Public Sub ClipText() As String
	Dim Tmp As String
	Tmp = ""	
	For i = 0 To Mask.Length -1 
		If "UL?#".Contains(Mask(i))  Then
			Tmp = Tmp & txMask(i)
		End If
	Next
	Tmp = RTrim(Tmp)
	Return Tmp
End Sub

Public Sub Text(t As String)
	Dim strSt() As String
	Dim Ct As Short
	If t.Trim ="" Then t=" "
	strSt = Regex.Split("",t)
	Ct=0
	For i = 0 To Mask.Length-1
		If "UL?#".Contains(Mask(i)) Then
			txMask(i) = Chr(32)
		Else
			txMask(i) = Mask(i)
		End If 
	Next	
	For i = 0 To Mask.Length -1
		If "UL?#".Contains(Mask(i)) And Ct < Mask.Length Then
			If Mask(i) = "#" Then
				If numString.Contains(strSt(Ct)) Then 
					txMask(i) = strSt(Ct)
				End If
			Else If Mask(i) = "?" Then
				txMask(i) = strSt(Ct)
			Else If Mask(i) = "U" Then
				txMask(i) = strSt(Ct).ToUpperCase 
			Else If Mask(i) = "L" Then
				txMask(i) = strSt(Ct).ToLowerCase
			Else 
				txMask(i) = " "
				Log("Error: Invalid character")
				'Return
			End If			
			Ct = Ct + 1
			If Ct > strSt.Length-1 Then Exit
		End If
	Next
	putText
End Sub

Public Sub TollTipText(ttt As String)
	lbText.TooltipText = ttt
End Sub	

Public Sub RequestFocus
	btFocus.RequestFocus
End Sub

Public Sub Visible(vsb As Boolean)
	lbText.Visible = vsb
	btFocus.Visible = vsb
	mPane.Visible = vsb
	Caret_Pos = 0
	setCaret_Pos
End Sub

Public Sub isVisible As Boolean
	Return lbText.Visible
End Sub

public Sub obtain_Mask As String
	Dim m As String = ""
	For i = 0 To Mask.Length-1
		m = m & Mask(i)
	Next
	Return m
End Sub	
	
Public Sub NewMask(m As String)
	Dim newT As String = ClipText
	sMask(m)
	Text(newT)
End Sub	

Private Sub MeasureText(Txt As String,TFont As Font) As Int()
    Dim TB,Bounds As JavaObject
    Dim TM(2) As Int
    TB.InitializeStatic("javafx.scene.text.TextBuilder")
    Bounds = TB.RunMethodJO("create",Null).RunMethodJO("text",Array(Txt)).RunMethodJO("font",Array(TFont)).RunMethodJO("build",Null).RunMethodJO("getLayoutBounds",Null)
    TM(0) = Bounds.RunMethod("getWidth",Null)
    TM(1) = Bounds.RunMethod("getHeight",Null)
    Return TM
End Sub

Private Sub RTrim(s As String) As String
	Dim ct As Short = 0
	Dim lg As Short = s.Length
   	For i = lg-1 To 0 Step-1
   		If s.SubString2(i,i + 1)<> " " Then Exit
		ct=ct+1
	Next
   	Return s.SubString2(0, lg - ct)
End Sub

Private Sub getRGB(rgb_Clr As Int) As Short()
    Dim Ret(4) As Short
    Ret(0) 	= Bit.UnsignedShiftRight(Bit.And(rgb_Clr, 0xff000000), 24)	
    Ret(1) 	= Bit.UnsignedShiftRight(Bit.And(rgb_Clr, 0xff0000), 16)
    Ret(2) 	= Bit.UnsignedShiftRight(Bit.And(rgb_Clr, 0xff00), 8)
	Ret(3) 	= Bit.And(rgb_Clr, 0xff)
    Return Ret
End Sub
